import numpy as np
from util import makeEdgeMat

def basic_powerpagerank(E, Ig, tol=1.0e-8, maxit=1000):

    # your code goes here

    if iter >= maxit:
        print("No convergence")
    return Ipower, iter

if __name__ == '__main__':
    np.set_printoptions(suppress=True)

    print("Test 1: Normal execution")
    E = makeEdgeMat('graph1.dat')
    Ig = np.ones(E.shape[0])/E.shape[0]
    I, iter = basic_powerpagerank(E, Ig)
    print('I =', I)
    print('iterations =', iter, '\n')

    print("Test 2: Dangling node (all zero)")
    E = makeEdgeMat('graph2.dat')
    Ig = np.zeros(E.shape[0])
    Ig[0] = 1
    I, iter = basic_powerpagerank(E, Ig)
    print('I =', I)
    print('iterations =', iter, '\n')

    print("Test 3: Dangling node (unsatisfactory result)")
    E = makeEdgeMat('graph2.dat')
    Ig = np.ones(E.shape[0])/E.shape[0]
    I, iter = basic_powerpagerank(E, Ig)
    print('I =', I)
    print('iterations =', iter, '\n')

    print("Test 4: Loop (no convergence)")
    E = makeEdgeMat('graph3.dat')
    Ig = np.zeros(E.shape[0])
    Ig[0] = 1
    I, iter = basic_powerpagerank(E, Ig)
    print('I =', I)
    print('iterations =', iter, '\n')

    print("Test 5: Loop (valid convergence)")
    E = makeEdgeMat('graph3.dat')
    Ig = np.ones(E.shape[0])/E.shape[0]
    I, iter = basic_powerpagerank(E, Ig)
    print('I =', I)
    print('iterations =', iter, '\n')

    print("Test 6: Sink (unsatisfactory result)")
    E = makeEdgeMat('graph4.dat')
    Ig = np.ones(E.shape[0])/E.shape[0]
    I, iter = basic_powerpagerank(E, Ig)
    print('I =', I)
    print('iterations =', iter, '\n')
