import numpy as np
from util import makeEdgeMat

def powerpagerank(E, alpha, Ig, tol=1.0e-8, maxit=1000):

    # write your code here

    return Ipower, iter

if __name__ == '__main__':
    np.set_printoptions(suppress=True)

    print('Test 1: Stochastic')
    E = makeEdgeMat('graph1.dat')
    Ig = np.ones(E.shape[0])/E.shape[0]
    I, iter = powerpagerank(E, 0.85, Ig)
    print('I =', I)
    print('iterations =', iter, '\n')

    print('Test 2: Dangling node')
    E = makeEdgeMat('graph2.dat')
    Ig = np.zeros(E.shape[0])
    Ig[0] = 1
    I, iter = powerpagerank(E, 0.85, Ig)
    print('I =', I)
    print('iterations =', iter, '\n')

    print('Test 3: Loop (Not primitive)')
    E = makeEdgeMat('graph3.dat')
    Ig = np.zeros(E.shape[0])
    Ig[0] = 1
    I, iter = powerpagerank(E, 0.85, Ig)
    print('I =', I)
    print('iterations =', iter, '\n')

    print('Test 4: Sink (reducible)')
    E = makeEdgeMat('graph4.dat')
    Ig = np.ones(E.shape[0])/E.shape[0]
    I, iter = powerpagerank(E, 0.85, Ig)
    print('I =', I)
    print('iterations =', iter, '\n')

    print('Test 5: Custom graph')
    # write your code here
    Ig = np.ones(E.shape[0])/E.shape[0]
    I, iter = powerpagerank(E, 0.85, Ig)
    print('I =', I)
    print('iterations =', iter, '\n')

    print('Test 6: Effect of alpha on number of iterations')
    print('alpha\titerations')
    for alpha in np.arange(0.05, 1.00, 0.05):
        I, iter = powerpagerank(E, alpha, Ig)
        print('{0:3.2f}\t{1:5d}'.format(alpha, iter))

